//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//+------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_level1  0

//
//
//
//
//

extern int    BarsPerSymbol        = 70;
extern string Symbols              = "EURUSD;GBPUSD;USDCHF";
extern int    BBPeriod             = 15;
extern int    BBPrice              = PRICE_WEIGHTED;
extern double BBDeviations1        = 1.0;
extern double BBDeviations2        = 2.0;
extern double BBDeviations3        = 3.0;
extern color  WickColor            = Gray;
extern color  BodyUpColor          = LimeGreen;
extern color  BodyDownColor        = PaleVioletRed;
extern int    BodyWidth            = 3;
extern bool   DrawAsBack           = false;
extern string UniqueID             = "MuktiBB bars 1";
extern string _                    = "separator colors";
extern color  textColor            = Black;
extern color  backColor            = LightGray;
extern color  zeroCrossUpColor     = LimeGreen;
extern color  zeroCrossDownColor   = HotPink;
extern int    separatorWidth       = 6;

//
//
//
//
//

double bandUp1[];
double bandDn1[];
double bandUp2[];
double bandDn2[];
double bandUp3[];
double bandDn3[];

//
//
//
//
//

int      window;  
string   aPairs[];
string   shortName;
double   minValue;
double   maxValue;
double   maxValues[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandUp1);
   SetIndexBuffer(1,bandDn1);
   SetIndexBuffer(2,bandUp2);
   SetIndexBuffer(3,bandDn2);
   SetIndexBuffer(4,bandUp3);
   SetIndexBuffer(5,bandDn3);
   
      //
      //
      //
      //
      //

      Symbols = StringTrimLeft(StringTrimRight(Symbols));
      if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                       Symbols = StringConcatenate(Symbols,";");

         //
         //
         //
         //
         //                                   
            
         int s =  0;
         int i =  StringFind(Symbols,";",s);
         while (i > 0)
         {
            string current = StringSubstr(Symbols,s,i-s);
            ArrayResize(aPairs,ArraySize(aPairs)+1);
                        aPairs[ArraySize(aPairs)-1] = current;
                        if (current == Symbol())
                        {
                           string temp      = aPairs[0];
                                  aPairs[0] = current;
                                  aPairs[ArraySize(aPairs)-1] = temp;
                        }                                       
            s = i + 1;
            i = StringFind(Symbols,";",s);
         }
         ArrayResize(maxValues,ArraySize(aPairs));

      //
      //
      //
      //
      //
 
      separatorWidth = MathMax(separatorWidth,4);
      shortName      = UniqueID;
	IndicatorShortName(UniqueID); 
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i); if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define _open  0
#define _close 1
#define _high  2
#define _low   3
int start()
{
   int    i,k,limit = ArraySize(aPairs);
   double max;
   
   //
   //
   //
   //
   //

   window = WindowFind(shortName);  
   ArrayInitialize(maxValues,0);
         minValue = 0;
         maxValue = 0;
                for(i=0,k=0; i<limit; i++) calculateValues(aPairs[i],BarsPerSymbol,k,i);
                for(i=0;     i<limit; i++) if (max < maxValues[i]) max = maxValues[i];
                for(i=0,k=0; i<limit; i++) plotGraph(aPairs[i],BarsPerSymbol,k,i,max);
   for (i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,Bars-k);
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void plotGraph(string symbol,int limit, int& shift,int element, double max)
{
   createLabel(symbol,element,shift+limit+separatorWidth-2,max,isSignalCrossing(shift));
   
   //
   //
   //
   //
   //
   
   shift += (limit+separatorWidth-1);
}

//
//
//
//
//

int isSignalCrossing(int shift)
{
   return(0);    
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void calculateValues(string symbol,int limit,int& shift,int element)
{
   if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
   for(int i=0; i<limit; i++)
   {
      double deviation = iStdDev(symbol,0,BBPeriod,0,MODE_SMA,BBPrice,i);
      double ma        = iMA(symbol,0,BBPeriod,0,MODE_SMA,BBPrice,i);
         bandUp1[i+shift] =  BBDeviations1*deviation;
         bandDn1[i+shift] = -BBDeviations1*deviation;
         bandUp2[i+shift] =  BBDeviations2*deviation;
         bandDn2[i+shift] = -BBDeviations2*deviation;
         bandUp3[i+shift] =  BBDeviations3*deviation;
         bandDn3[i+shift] = -BBDeviations3*deviation;
         work[Bars-i-shift-1][_open]  = iOpen(symbol,0,i) -ma;
         work[Bars-i-shift-1][_close] = iClose(symbol,0,i)-ma;
         work[Bars-i-shift-1][_high]  = iHigh(symbol,0,i) -ma;
         work[Bars-i-shift-1][_low]   = iLow(symbol,0,i)  -ma;
         drawCandle(i+shift);
   
      maxValues[element] = MathMax(MathMax(work[Bars-i-shift-1][_high],bandUp1[i+shift]),maxValues[element]);
      maxValues[element] = MathMax(MathMax(work[Bars-i-shift-1][_high],bandUp2[i+shift]),maxValues[element]);
      maxValues[element] = MathMax(MathMax(work[Bars-i-shift-1][_high],bandUp3[i+shift]),maxValues[element]);
      maxValue           = MathMax(MathMax(work[Bars-i-shift-1][_high],bandUp1[i+shift]),maxValue);
      maxValue           = MathMax(MathMax(work[Bars-i-shift-1][_high],bandUp2[i+shift]),maxValue);
      maxValue           = MathMax(MathMax(work[Bars-i-shift-1][_high],bandUp3[i+shift]),maxValue);
      minValue           = MathMin(MathMin(work[Bars-i-shift-1][_low] ,bandDn1[i+shift]),minValue);
      minValue           = MathMin(MathMin(work[Bars-i-shift-1][_low] ,bandDn2[i+shift]),minValue);
      minValue           = MathMin(MathMin(work[Bars-i-shift-1][_low] ,bandDn3[i+shift]),minValue);
   }            

   //
   //
   //
   //
   //

   for (i=0;i<separatorWidth;i++)
      {
         bandUp1[shift+limit+i] = EMPTY_VALUE;
         bandDn1[shift+limit+i] = EMPTY_VALUE;
         bandUp2[shift+limit+i] = EMPTY_VALUE;
         bandDn2[shift+limit+i] = EMPTY_VALUE;
         bandUp3[shift+limit+i] = EMPTY_VALUE;
         bandDn3[shift+limit+i] = EMPTY_VALUE;
         string name = UniqueID+":"+Time[shift+limit+i]+":";     ObjectDelete(name);
                name = UniqueID+":"+Time[shift+limit+i]+":body"; ObjectDelete(name);
      }         
   shift += (limit+separatorWidth-1);
   return;
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void createLabel(string symbol,int element, int shift, double max, int signalCrossing)
{
   string name = shortName+element;
   double price1 = maxValue;
   double price2 = minValue;
   
   //
   //
   //
   //
   //
   
   if (ObjectFind(name) == -1)
       ObjectCreate(name,OBJ_TEXT,window,0,0);
            ObjectSet(name,OBJPROP_ANGLE,90);
            ObjectSet(name,OBJPROP_TIME1 ,Time[shift]);
            ObjectSet(name,OBJPROP_PRICE1,(price1+price2)/2);
            ObjectSet(name,OBJPROP_COLOR,textColor);
            ObjectSetText(name,symbol,10,"Arial bold");

   //
   //
   //
   //
   //

   name = shortName+element+element;
   if (ObjectFind(name) == -1)
         ObjectCreate(name,OBJ_RECTANGLE,window,0,0,0,0);
            ObjectSet(name,OBJPROP_COLOR,backColor);
            ObjectSet(name,OBJPROP_TIME1,Time[shift]);
            ObjectSet(name,OBJPROP_PRICE1,price1);
            ObjectSet(name,OBJPROP_TIME2,Time[shift-(separatorWidth-2)]);
            ObjectSet(name,OBJPROP_PRICE2,price2);
            if (signalCrossing!=0)
                 if (signalCrossing>0)
                        ObjectSet(name,OBJPROP_COLOR,zeroCrossUpColor);
                 else   ObjectSet(name,OBJPROP_COLOR,zeroCrossDownColor);
            else ObjectSet(name,OBJPROP_COLOR,backColor);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
  
void drawCandle(int i)
{
   datetime time = Time[i];
   string   name = UniqueID+":"+time+":";
   
      ObjectCreate(name,OBJ_TREND,window,0,0,0,0);
         ObjectSet(name,OBJPROP_COLOR,WickColor);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSet(name,OBJPROP_TIME2,time);
         ObjectSet(name,OBJPROP_PRICE1,MathMax(work[Bars-i-1][_high],MathMin(work[Bars-i-1][_close],work[Bars-i-1][_open])));
         ObjectSet(name,OBJPROP_PRICE2,MathMin(work[Bars-i-1][_low] ,MathMax(work[Bars-i-1][_close],work[Bars-i-1][_open])));
         ObjectSet(name,OBJPROP_RAY ,false);
         ObjectSet(name,OBJPROP_BACK,DrawAsBack);
      
   //
   //
   //
   //
   //
         
   name = name+"body";
      ObjectCreate(name,OBJ_TREND,window,0,0,0,0);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSet(name,OBJPROP_TIME2,time);
         ObjectSet(name,OBJPROP_PRICE1,work[Bars-i-1][_open]);
         ObjectSet(name,OBJPROP_PRICE2,work[Bars-i-1][_close]);
         ObjectSet(name,OBJPROP_WIDTH,BodyWidth);
         ObjectSet(name,OBJPROP_RAY  ,false);
         ObjectSet(name,OBJPROP_BACK,DrawAsBack);
         if (work[Bars-i-1][_open]<work[Bars-i-1][_close])
               ObjectSet(name,OBJPROP_COLOR,BodyUpColor);
         else  ObjectSet(name,OBJPROP_COLOR,BodyDownColor);
}